// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ionic-datepicker', 'ion-datetime-picker', 'starter.controllers', 'ngCordova'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider, ionicDatePickerProvider) {
  $stateProvider

    .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/social/menu.html",
      controller: 'AppCtrl'
    })

    .state('app.feed', {
      url: "/feed",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/feed.html"
        }
      }
    })

    .state('app.start', {
      url: "/start",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/start-fullscreen.html"
        }
      }
    })

    .state('app.fgrid', {
      url: "/fgrid",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/friend-grid.html",
		  controller: 'InviteCtrl',
        }
      }
    })

    .state('app.flist', {
      url: "/flist",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/friends.html",
		  controller: 'InviteCtrl',
        }
      }
    })
	
	.state('app.locations', {
      url: "/locations",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/locations.html",
		  controller: 'LocCtrl',
        }
      }
    })

    .state('app.newpost', {
      url: "/newpost",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/new-post.html"
        }
      }
    })

    .state('app.email', {
      url: "/email",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/send-email.html"
        }
      }
    })    

    .state('app.profile', {
      url: "/profile",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/profile.html",
		  controller: 'ProfileCtrl',
        }
      }
    })
	.state('app.editclub', {
      url: "/editclub",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/editclub.html",
		  controller: 'ProfileEditCtrl',
        }
      }
    })
	
	.state('app.notifysettings', {
      url: "/notifysettings",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/notifysettings.html",
		  controller: 'NotifySettingsCtrl',
        }
      }
    })
	
	.state('app.notifytype', {
      url: "/notifytype/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/notifytype.html",
		  controller: 'NotifySettingsCtrl',
        }
      },
	  params : {id : null}
    })
	
	.state('app.notifydetails', {
      url: "/notifydetails/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/notifydetails.html",
		  controller: 'NotifySettingsCtrl',
        }
      },
	  params : {id : null}
    })

    .state('app.timeline', {
      url: "/timeline",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/timeline.html",
        }
      }
    })

   /* .state('app.editprofile', {
      url: "/editprofile",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/profile-edit.html",
        }
      }
    })*/
	 .state('app.publishjob', {
      url: "/publishjob",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/publishjob.html",
		  controller: 'PublishjobCtrl',
        }
      }
    })
	
	 .state('app.postvacancy', {
      url: "/postvacancy",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/postvacancy.html",
		  controller: 'PostvacancyCtrl',
        }
      }
    })


    .state('app.profiletwo', {
      url: "/profiletwo",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/profile2.html",
        }
      }
    })

    .state('app.gallery', {
      url: "/gallery",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/gallery.html",
        }
      }
    })
	
	 .state('app.reviews', {
      url: "/reviews",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/reviews.html",
		  controller: 'ReviewCtrl',
        }
      }
    })
	
	.state('app.favlist', {
      url: "/favlist",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/favorites.html",
		  controller: 'FavCtrl',
        }
      }
    })
	
	 .state('app.search-filter', {
      url: "/search-filter",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/search-filter.html",
        }
      }
    })

    .state('app.news', {
      url: "/news",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/news.html",
        }
      }
    })

    .state('app.viewpost', {
      url: "/viewpost",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/view-post.html",
        }
      }
    })

    .state('app.viewposttwo', {
      url: "/viewposttwo",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/view-post-2.html",
        }
      }
    })
	
	  .state('app.booking', {
      url: "/booking/:jobId",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/booking.html",
		  controller: 'BookingCtrl',
        }
      }
    })
	
	.state('app.notification_view', {
      url: "/notification_view/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/notification_view.html",
		  controller: 'NotifyCtrl',
        }
      },
	  params : { id : null }
    })

    .state('app.mybookings', {
      url: "/mybookings",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/mybookings.html",
		  controller: 'BookingsCtrl',
        }
      }
    })
	
	 .state('app.editprofile1', {
      url: "/editprofile1",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/editprofile1.html",
		  controller: 'InstEditCtrl',
        }
      }
    })
	 .state('app.editprofile', {
      url: "/editprofile",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/editprofile.html",
		  controller: 'InstEditCtrl',
        }
      }
    })
	
	.state('app.notifications', {
      url: "/notifications",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/notifications.html",
		  controller: 'NotifyCtrl',
        }
      }
    })
	
	.state('app.register', {
      url: "/register",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/register.html",
        }
      }
    })
	
	.state('app.repeating-status', {
      url: "/repeating-status",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/repeating-status.html",
        }
      }
    })
	
	.state('app.update-availablity', {
      url: "/update-availablity",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/update-availablity.html",
        }
      }
    })

	.state('app.all_availablity', {
      url: "/all_availablity",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/all_availablity.html",
		  controller: 'allavailablityCtrl',
        }
      }
    })
	
	.state('app.viewavail', {
      url: "/viewavail/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/viewavail.html",
		  controller: 'viewavailablityCtrl',
        }
      },
	  params : {id : null}
    })
	

	.state('app.availability_update', {
      url: "/availability_update",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/availability_update.html",
		  controller: 'AvailabilityCtrl',
        }
      }
    })
	
	.state('app.availability', {
      url: "/availability",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/availability.html",
		  controller: 'CalendarCtrl',
        }
      }
    })
	
	.state('app.forgot', {
      url: "/forgot",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/forgot.html",
        }
      }
    })
	
	.state('app.clubs', {
      url: "/clubs",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/clubs.html",
		  controller: 'ClubCtrl',
        }
      }
    })
	
	.state('app.club_view', {
      url: "/club_view/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/club_view.html",
		  controller: 'clubviewCtrl',
        }
      },
	  params : { id : null }
    })
	
	.state('app.add_comment_club', {
      url: "/add_comment_club/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/add_comment_club.html",
		  controller : 'comment_club_Ctrl',
        }
      }
    })
	
	.state('app.setuprepeat', {
      url: "/setuprepeat/:id",
      views: {
        'menuContent' :{
          templateUrl: "templates/social/setuprepeat.html",
		  controller: 'AvailabilityCtrl',
        }
      }
    })
	

    
  // if none of the above states are matched, use this as the fallback
  if(window.localStorage.getItem("userid")!=undefined && window.localStorage.getItem("userid")!='')
  {
    $urlRouterProvider.otherwise('/app/notifications');
  }
  else
  {
    $urlRouterProvider.otherwise('/app/start');
  }
  //datepicker
  var datePickerObj = {
      inputDate: new Date(),
      setLabel: 'Set',
      todayLabel: 'Today',
      closeLabel: 'Close',
      mondayFirst: false,
      weeksList: ["S", "M", "T", "W", "T", "F", "S"],
      monthsList: ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"],
      templateType: 'popup',
      from: new Date(2012, 8, 1),
      to: new Date(2018, 8, 1),
      showTodayButton: true,
      dateFormat: 'dd MMMM yyyy',
      closeOnSelect: false,
      disableWeekdays: [6]
    };
    ionicDatePickerProvider.configDatePicker(datePickerObj);
})
.service('sharedProperties', function () {
	var jobId = '';

	return {
		getJobId: function () {
			return jobId;
		},
		setJobId: function(value) {
			jobId = value;
		}
	};
})
.directive('starRating', function () {
    return {
        scope: {
            rating: '=',
            maxRating: '@',
            readOnly: '@',
            click: "&",
            mouseHover: "&",
            mouseLeave: "&"
        },
        restrict: 'EA',
        template:
            "<div style='display: inline-block; margin: 0px; padding: 0px; cursor:pointer;' ng-repeat='idx in maxRatings track by $index'> \
                    <img ng-src='{{((hoverValue + _rating) <= $index) && \"http://www.codeproject.com/script/ratings/images/star-empty-md.png\" || \"http://www.codeproject.com/script/ratings/images/star-fill-md.png\"}}' \
                    ng-Click='isolatedClick($index + 1)' \
                    ng-mouseenter='isolatedMouseHover($index + 1)' \
                    ng-mouseleave='isolatedMouseLeave($index + 1)'></img> \
            </div>",
        compile: function (element, attrs) {
            if (!attrs.maxRating || (Number(attrs.maxRating) <= 0)) {
                attrs.maxRating = '5';
            };
        },
        controller: function ($scope, $element, $attrs) {
            $scope.maxRatings = [];

            for (var i = 1; i <= $scope.maxRating; i++) {
                $scope.maxRatings.push({});
            };

            $scope._rating = $scope.rating;
			
			$scope.isolatedClick = function (param) {
				if ($scope.readOnly == 'true') return;

				$scope.rating = $scope._rating = param;
				$scope.hoverValue = 0;
				$scope.click({
					param: param
				});
			};

			$scope.isolatedMouseHover = function (param) {
				if ($scope.readOnly == 'true') return;

				$scope._rating = 0;
				$scope.hoverValue = param;
				$scope.mouseHover({
					param: param
				});
			};

			$scope.isolatedMouseLeave = function (param) {
				if ($scope.readOnly == 'true') return;

				$scope._rating = $scope.rating;
				$scope.hoverValue = 0;
				$scope.mouseLeave({
					param: param
				});
			};
        }
    };
})
.directive("calendar", function($http) {
	return {
		restrict: "E",
		templateUrl: "templates/social/calendar.html",
		controller: "DaysCtrl",
		scope: {
			selected: "=",
			time: '@'
		},
		link: function(scope) {			
			scope.selected = _removeTime(scope.selected || moment());
			scope.month = scope.selected.clone();

			var start = scope.selected.clone();
			start.date(1);
			_removeTime(start.day(0));
			
			_buildMonth(scope, start, scope.month, scope.vacdates);
			$http.get(scope.baseUrl+'api/api.php?action=getInstavail&id='+window.localStorage.getItem("userid")).then(function(response){
				scope.vacdates = response.data.vacdates;
				_buildMonth(scope, start, scope.month, scope.vacdates);
			});
			scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
				$http.get(scope.baseUrl+'api/api.php?action=getInstavail&id='+window.localStorage.getItem("userid")).then(function(response){
					scope.vacdates = response.data.vacdates;
					_buildMonth(scope, start, scope.month, scope.vacdates);
				});
			});
			
			scope.select = function(day) {
				scope.selected = day.date;  
			};
			
			scope.next = function() {
			var next = scope.month.clone();
			_removeTime(next.month(next.month()+1).date(1));
			scope.month.month(scope.month.month()+1);
			_buildMonth(scope, next, scope.month, scope.vacdates);
			};
			
			scope.previous = function() {
			var previous = scope.month.clone();
			_removeTime(previous.month(previous.month()-1).date(1));
			scope.month.month(scope.month.month()-1);
			_buildMonth(scope, previous, scope.month, scope.vacdates);
			};
			
		}
	};

	function _removeTime(date) {
		return date.day(0).hour(0).minute(0).second(0).millisecond(0);
	}

	function _buildMonth(scope, start, month, vacdates) {
		scope.weeks = [];
		var done = false, date = start.clone(), monthIndex = date.month(), count = 0;
		while (!done) {
			scope.weeks.push({ days: _buildWeek(date.clone(), month, vacdates) });
			date.add(1, "w");
			done = count++ > 2 && monthIndex !== date.month();
			monthIndex = date.month();
		}
	}
	function isWeekend(date) {
		return (date.getDay() === 6) || (date.getDay() === 0);
	};
	function isWeekday(date) {
		return (date.getDay() !== 6) && (date.getDay() !== 0);
	};
	function _buildWeek(date, month, vacdates) {
		var days = [];
		for (var i = 0; i < 7; i++) {
			var dt = date.year() + '-' + ('0' + (date.month()+1)).slice(-2) + '-' + ('0' + date.date()).slice(-2);
			
			var avail = vacdates.availdates.indexOf(dt);
			var unavail = vacdates.unavaildates.indexOf(dt);
			var upavail = vacdates.upavaildates.indexOf(dt);
			var downavail = vacdates.downavaildates.indexOf(dt);
			if(vacdates.repeatavaildate!=''){
				var rd = new Date(vacdates.repeatavaildate);
				var cd = new Date(date);
				if(rd.getTime()<=cd.getTime()){
					if(vacdates.repeatst==1 && vacdates.repeattype==1){
						if(vacdates.repeatstatus==1){
							avail=1;
						}
						else if(vacdates.repeatstatus==2 && isWeekday(cd)){
							avail=1;
						}
						else if(vacdates.repeatstatus==3 && isWeekend(cd)){
							avail=1;
						}
					}
					if(vacdates.repeatst==0 && vacdates.repeattype==1){
						if(vacdates.repeatstatus==1){
							unavail=1;
						}
						else if(vacdates.repeatstatus==2 && isWeekday(cd)){
							unavail=1;
						}
						else if(vacdates.repeatstatus==3 && isWeekend(cd)){
							unavail=1;
						}
					}
					if(vacdates.repeatst==1 && vacdates.repeattype==2){
						if(vacdates.repeatstatus==1){
							upavail=1;
						}
						else if(vacdates.repeatstatus==2 && isWeekday(cd)){
							upavail=1;
						}
						else if(vacdates.repeatstatus==3 && isWeekend(cd)){
							upavail=1;
						}
					}
					if(vacdates.repeatst==1 && vacdates.repeattype==3){
						if(vacdates.repeatstatus==1){
							downavail=1;
						}
						else if(vacdates.repeatstatus==2 && isWeekday(cd)){
							downavail=1;
						}
						else if(vacdates.repeatstatus==3 && isWeekend(cd)){
							downavail=1;
						}
					}
				}				
			}
			
			days.push({
				name: date.format("dd").substring(0, 1),
				number: date.date(),
				isCurrentMonth: date.month() === month.month(),
				isToday: date.isSame(new Date(), "day"),
				date: date,
				isAvailable:avail>=0?true:false,
				isUnavailable:unavail>=0?true:false,
				isUpAvail:upavail>=0?true:false,
				isDownAvail:downavail>=0?true:false,
			});
			date = date.clone();
			date.add(1, "d");
		}
		return days;
	}
})
.config(function($ionicConfigProvider) {
    $ionicConfigProvider.backButton.text('').icon('ion-ios7-arrow-left').previousTitleText(false);
});